diff -crB c:\mame0106s\mame0106s\src/drivers/kaneko16.c c:\mingw9\mame\src/drivers/kaneko16.c
*** c:\mame0106s\mame0106s\src/drivers/kaneko16.c	Fri May  5 07:13:40 2006
--- c:\mingw9\mame\src/drivers/kaneko16.c	Mon Aug 15 11:25:03 2011
***************
*** 1556,1577 ****
  
  INPUT_PORTS_START( gtmr )
  	PORT_START	// IN0 - Player 1 - b00000.w
! 	PORT_BIT(  0x0100, IP_ACTIVE_LOW, IPT_JOYSTICK_UP ) PORT_8WAY PORT_PLAYER(1)
! 	PORT_BIT(  0x0200, IP_ACTIVE_LOW, IPT_JOYSTICK_DOWN ) PORT_8WAY PORT_PLAYER(1)
! 	PORT_BIT(  0x0400, IP_ACTIVE_LOW, IPT_JOYSTICK_LEFT ) PORT_8WAY PORT_PLAYER(1)
! 	PORT_BIT(  0x0800, IP_ACTIVE_LOW, IPT_JOYSTICK_RIGHT ) PORT_8WAY PORT_PLAYER(1)
! 	PORT_BIT(  0x1000, IP_ACTIVE_LOW, IPT_BUTTON2 ) PORT_PLAYER(1) // swapped for consistency:
! 	PORT_BIT(  0x2000, IP_ACTIVE_LOW, IPT_BUTTON1 ) PORT_PLAYER(1) // button1 is usually accel.
  	PORT_BIT(  0x4000, IP_ACTIVE_LOW, IPT_UNKNOWN )
  	PORT_BIT(  0x8000, IP_ACTIVE_LOW, IPT_UNKNOWN )
  
  	PORT_START	// IN1 - Player 2 - b00002.w
! 	PORT_BIT(  0x0100, IP_ACTIVE_LOW, IPT_JOYSTICK_UP ) PORT_8WAY PORT_PLAYER(2)
! 	PORT_BIT(  0x0200, IP_ACTIVE_LOW, IPT_JOYSTICK_DOWN ) PORT_8WAY PORT_PLAYER(2)
! 	PORT_BIT(  0x0400, IP_ACTIVE_LOW, IPT_JOYSTICK_LEFT ) PORT_8WAY PORT_PLAYER(2)
! 	PORT_BIT(  0x0800, IP_ACTIVE_LOW, IPT_JOYSTICK_RIGHT ) PORT_8WAY PORT_PLAYER(2)
! 	PORT_BIT(  0x1000, IP_ACTIVE_LOW, IPT_BUTTON2 ) PORT_PLAYER(2) // swapped for consistency:
! 	PORT_BIT(  0x2000, IP_ACTIVE_LOW, IPT_BUTTON1 ) PORT_PLAYER(2) // button1 is usually accel.
  	PORT_BIT(  0x4000, IP_ACTIVE_LOW, IPT_UNKNOWN )
  	PORT_BIT(  0x8000, IP_ACTIVE_LOW, IPT_UNKNOWN )
  
--- 1556,1577 ----
  
  INPUT_PORTS_START( gtmr )
  	PORT_START	// IN0 - Player 1 - b00000.w
! 	PORT_BIT(  0x0100, IP_ACTIVE_LOW, IPT_UNUSED ) PORT_8WAY PORT_PLAYER(1)
! 	PORT_BIT(  0x0200, IP_ACTIVE_LOW, IPT_UNUSED ) PORT_8WAY PORT_PLAYER(1)
! 	PORT_BIT(  0x0400, IP_ACTIVE_LOW, IPT_UNUSED ) PORT_8WAY PORT_PLAYER(1)
! 	PORT_BIT(  0x0800, IP_ACTIVE_LOW, IPT_UNUSED ) PORT_8WAY PORT_PLAYER(1)
! 	PORT_BIT(  0x1000, IP_ACTIVE_LOW, IPT_BUTTON2 ) PORT_PLAYER(1) PORT_NAME("P1 Brake")// swapped for consistency:
! 	PORT_BIT(  0x2000, IP_ACTIVE_LOW, IPT_BUTTON1 ) PORT_PLAYER(1) PORT_NAME("P1 Accelerator")// button1 is usually accel.
  	PORT_BIT(  0x4000, IP_ACTIVE_LOW, IPT_UNKNOWN )
  	PORT_BIT(  0x8000, IP_ACTIVE_LOW, IPT_UNKNOWN )
  
  	PORT_START	// IN1 - Player 2 - b00002.w
! 	PORT_BIT(  0x0100, IP_ACTIVE_LOW, IPT_UNUSED ) PORT_8WAY PORT_PLAYER(2)
! 	PORT_BIT(  0x0200, IP_ACTIVE_LOW, IPT_UNUSED ) PORT_8WAY PORT_PLAYER(2)
! 	PORT_BIT(  0x0400, IP_ACTIVE_LOW, IPT_UNUSED ) PORT_8WAY PORT_PLAYER(2)
! 	PORT_BIT(  0x0800, IP_ACTIVE_LOW, IPT_UNUSED ) PORT_8WAY PORT_PLAYER(2)
! 	PORT_BIT(  0x1000, IP_ACTIVE_LOW, IPT_BUTTON2 ) PORT_PLAYER(2) PORT_NAME("P2 Brake")// swapped for consistency:
! 	PORT_BIT(  0x2000, IP_ACTIVE_LOW, IPT_BUTTON1 ) PORT_PLAYER(2) PORT_NAME("P2 Accelerator")// button1 is usually accel.
  	PORT_BIT(  0x4000, IP_ACTIVE_LOW, IPT_UNKNOWN )
  	PORT_BIT(  0x8000, IP_ACTIVE_LOW, IPT_UNKNOWN )
  
***************
*** 1603,1611 ****
  	PORT_DIPNAME( 0x0400, 0x0400, DEF_STR( Cabinet )  )
  	PORT_DIPSETTING(      0x0400, DEF_STR( Upright )  )
  	PORT_DIPSETTING(      0x0000, DEF_STR( Cocktail ) )
! 	PORT_DIPNAME( 0x1800, 0x1800, DEF_STR( Controls )    )
! 	PORT_DIPSETTING(      0x1800, "1 Joystick"  )
! 	PORT_DIPSETTING(      0x0800, "2 Joysticks" )
  	PORT_DIPSETTING(      0x1000, "Wheel (360)" )
  	PORT_DIPSETTING(      0x0000, "Wheel (270)" )
  	PORT_DIPNAME( 0x2000, 0x2000, "Use Brake"    )
--- 1603,1615 ----
  	PORT_DIPNAME( 0x0400, 0x0400, DEF_STR( Cabinet )  )
  	PORT_DIPSETTING(      0x0400, DEF_STR( Upright )  )
  	PORT_DIPSETTING(      0x0000, DEF_STR( Cocktail ) )
! 	
! if(options.steertype!=1)
! 	{PORT_DIPNAME( 0x1000, 0x0000, DEF_STR( Controls )    )}
! else
! 	{PORT_DIPNAME( 0x1000, 0x1000, DEF_STR( Controls )    )}
! 	//PORT_DIPSETTING(      0x1800, "1 Joystick"  )
! 	//PORT_DIPSETTING(      0x0800, "2 Joysticks" )
  	PORT_DIPSETTING(      0x1000, "Wheel (360)" )
  	PORT_DIPSETTING(      0x0000, "Wheel (270)" )
  	PORT_DIPNAME( 0x2000, 0x2000, "Use Brake"    )
***************
*** 1618,1624 ****
  	PORT_DIPSETTING(      0x0000, DEF_STR( None )        )
  
  	PORT_START	// IN5 - Wheel - 100015.b <- ffffe.b
! 	PORT_BIT ( 0x00ff, 0x0080, IPT_PADDLE ) PORT_MINMAX(0x00,0xff) PORT_SENSITIVITY(30) PORT_KEYDELTA(1)
  INPUT_PORTS_END
  
  
--- 1622,1628 ----
  	PORT_DIPSETTING(      0x0000, DEF_STR( None )        )
  
  	PORT_START	// IN5 - Wheel - 100015.b <- ffffe.b
! 	PORT_BIT ( 0x00ff, 0x0080, IPT_PADDLE ) PORT_MINMAX(0x00,0xff) PORT_SENSITIVITY(30) PORT_KEYDELTA(1) PORT_NAME("Steering")
  INPUT_PORTS_END
  
  
***************
*** 1628,1649 ****
  
  INPUT_PORTS_START( gtmr2 )
  	PORT_START	// IN0 - Player 1 - 100004.w <- b00000.w (cpl)
! 	PORT_BIT(  0x0100, IP_ACTIVE_LOW, IPT_JOYSTICK_UP ) PORT_8WAY PORT_PLAYER(1)
! 	PORT_BIT(  0x0200, IP_ACTIVE_LOW, IPT_JOYSTICK_DOWN ) PORT_8WAY PORT_PLAYER(1)
! 	PORT_BIT(  0x0400, IP_ACTIVE_LOW, IPT_JOYSTICK_LEFT ) PORT_8WAY PORT_PLAYER(1)
! 	PORT_BIT(  0x0800, IP_ACTIVE_LOW, IPT_JOYSTICK_RIGHT ) PORT_8WAY PORT_PLAYER(1)
! 	PORT_BIT(  0x1000, IP_ACTIVE_LOW, IPT_BUTTON2 ) PORT_PLAYER(1) // swapped for consistency:
! 	PORT_BIT(  0x2000, IP_ACTIVE_LOW, IPT_BUTTON1 ) PORT_PLAYER(1) // button1 is usually accel.
  	PORT_BIT(  0x4000, IP_ACTIVE_LOW, IPT_UNKNOWN )
  	PORT_BIT(  0x8000, IP_ACTIVE_LOW, IPT_UNKNOWN )
  
  	PORT_START	// IN1 - Player 2 - 10000c.w <- b00002.w (cpl) - for "test mode" only
! 	PORT_BIT(  0x0100, IP_ACTIVE_LOW, IPT_JOYSTICK_UP ) PORT_8WAY PORT_PLAYER(2)
! 	PORT_BIT(  0x0200, IP_ACTIVE_LOW, IPT_JOYSTICK_DOWN ) PORT_8WAY PORT_PLAYER(2)
! 	PORT_BIT(  0x0400, IP_ACTIVE_LOW, IPT_JOYSTICK_LEFT ) PORT_8WAY PORT_PLAYER(2)
! 	PORT_BIT(  0x0800, IP_ACTIVE_LOW, IPT_JOYSTICK_RIGHT ) PORT_8WAY PORT_PLAYER(2)
! 	PORT_BIT(  0x1000, IP_ACTIVE_LOW, IPT_BUTTON2 ) PORT_PLAYER(2) // swapped for consistency:
! 	PORT_BIT(  0x2000, IP_ACTIVE_LOW, IPT_BUTTON1 ) PORT_PLAYER(2) // button1 is usually accel.
  	PORT_BIT(  0x4000, IP_ACTIVE_LOW, IPT_UNKNOWN )
  	PORT_BIT(  0x8000, IP_ACTIVE_LOW, IPT_UNKNOWN )
  
--- 1632,1653 ----
  
  INPUT_PORTS_START( gtmr2 )
  	PORT_START	// IN0 - Player 1 - 100004.w <- b00000.w (cpl)
! 	PORT_BIT(  0x0100, IP_ACTIVE_LOW, IPT_UNUSED ) PORT_8WAY PORT_PLAYER(1)
! 	PORT_BIT(  0x0200, IP_ACTIVE_LOW, IPT_UNUSED ) PORT_8WAY PORT_PLAYER(1)
! 	PORT_BIT(  0x0400, IP_ACTIVE_LOW, IPT_UNUSED ) PORT_8WAY PORT_PLAYER(1)
! 	PORT_BIT(  0x0800, IP_ACTIVE_LOW, IPT_UNUSED ) PORT_8WAY PORT_PLAYER(1)
! 	PORT_BIT(  0x1000, IP_ACTIVE_LOW, IPT_BUTTON2 ) PORT_PLAYER(1) PORT_NAME("P1 Brake")// swapped for consistency:
! 	PORT_BIT(  0x2000, IP_ACTIVE_LOW, IPT_BUTTON1 ) PORT_PLAYER(1) PORT_NAME("P1 Accelerator")// button1 is usually accel.
  	PORT_BIT(  0x4000, IP_ACTIVE_LOW, IPT_UNKNOWN )
  	PORT_BIT(  0x8000, IP_ACTIVE_LOW, IPT_UNKNOWN )
  
  	PORT_START	// IN1 - Player 2 - 10000c.w <- b00002.w (cpl) - for "test mode" only
! 	PORT_BIT(  0x0100, IP_ACTIVE_LOW, IPT_UNUSED ) PORT_8WAY PORT_PLAYER(2)
! 	PORT_BIT(  0x0200, IP_ACTIVE_LOW, IPT_UNUSED ) PORT_8WAY PORT_PLAYER(2)
! 	PORT_BIT(  0x0400, IP_ACTIVE_LOW, IPT_UNUSED ) PORT_8WAY PORT_PLAYER(2)
! 	PORT_BIT(  0x0800, IP_ACTIVE_LOW, IPT_UNUSED ) PORT_8WAY PORT_PLAYER(2)
! 	PORT_BIT(  0x1000, IP_ACTIVE_LOW, IPT_BUTTON2 ) PORT_PLAYER(2) PORT_NAME("P2 Brake")// swapped for consistency:
! 	PORT_BIT(  0x2000, IP_ACTIVE_LOW, IPT_BUTTON1 ) PORT_PLAYER(2) PORT_NAME("P2 Accelerator")// button1 is usually accel.
  	PORT_BIT(  0x4000, IP_ACTIVE_LOW, IPT_UNKNOWN )
  	PORT_BIT(  0x8000, IP_ACTIVE_LOW, IPT_UNKNOWN )
  
***************
*** 1664,1670 ****
  	PORT_BIT(  0x0800, IP_ACTIVE_LOW, IPT_UNKNOWN )
  	PORT_BIT(  0x1000, IP_ACTIVE_LOW, IPT_UNKNOWN )
  	PORT_BIT(  0x2000, IP_ACTIVE_LOW, IPT_UNKNOWN )
! 	PORT_BIT( 0x4000, IP_ACTIVE_LOW, IPT_BUTTON3 ) PORT_NAME("IN 3-6")	// Code at 0x002236 - Centers 270D wheel ?
  	PORT_BIT(  0x8000, IP_ACTIVE_LOW, IPT_UNKNOWN )
  
  	PORT_START	// IN4 - DSW from the MCU - 1016f7.b <- 206000.b
--- 1668,1674 ----
  	PORT_BIT(  0x0800, IP_ACTIVE_LOW, IPT_UNKNOWN )
  	PORT_BIT(  0x1000, IP_ACTIVE_LOW, IPT_UNKNOWN )
  	PORT_BIT(  0x2000, IP_ACTIVE_LOW, IPT_UNKNOWN )
! 	PORT_BIT( 0x4000, IP_ACTIVE_LOW, IPT_UNUSED ) PORT_NAME("IN 3-6")	// Code at 0x002236 - Centers 270D wheel ?
  	PORT_BIT(  0x8000, IP_ACTIVE_LOW, IPT_UNKNOWN )
  
  	PORT_START	// IN4 - DSW from the MCU - 1016f7.b <- 206000.b
***************
*** 1679,1687 ****
      PORT_DIPSETTING(      0x0100, "Machine 4 (0x0100)" )
      PORT_DIPSETTING(      0x0000, "Machine 4 (0x0000)" )
      */
! 	PORT_DIPNAME( 0x1800, 0x1800, DEF_STR( Controls ) )
! 	PORT_DIPSETTING(      0x1800, DEF_STR( Joystick ) )
! 	PORT_DIPSETTING(      0x0800, "Wheel (360)" )			// Not working correctly in race
  	PORT_DIPSETTING(      0x1000, "Wheel (270D)" )			// Not working correctly !
  	PORT_DIPSETTING(      0x0000, "Wheel (270A)" )			// Not working correctly in race
  	PORT_DIPNAME( 0x2000, 0x2000, "Pedal Function" )
--- 1683,1693 ----
      PORT_DIPSETTING(      0x0100, "Machine 4 (0x0100)" )
      PORT_DIPSETTING(      0x0000, "Machine 4 (0x0000)" )
      */
! if(options.steertype!=1)
! 	{PORT_DIPNAME( 0x0800, 0x0000, DEF_STR( Controls ) )}	
! else
! 	{PORT_DIPNAME( 0x0800, 0x0800, DEF_STR( Controls ) )}
!     PORT_DIPSETTING(      0x0800, "Wheel (360)" )			// Not working correctly in race
  	PORT_DIPSETTING(      0x1000, "Wheel (270D)" )			// Not working correctly !
  	PORT_DIPSETTING(      0x0000, "Wheel (270A)" )			// Not working correctly in race
  	PORT_DIPNAME( 0x2000, 0x2000, "Pedal Function" )
***************
*** 1692,1714 ****
  	PORT_DIPSETTING(      0x0000, DEF_STR( On )  )
  	PORT_SERVICE( 0x8000, IP_ACTIVE_LOW )
  
! 	PORT_START	// IN5 - Wheel (270A) - 100019.b <- fffff.b
! 	PORT_BIT ( 0x00ff, 0x0080, IPT_PADDLE ) PORT_MINMAX(0x00,0xff) PORT_SENSITIVITY(30) PORT_KEYDELTA(1)
! 
! 	PORT_START	// IN6 - Wheel (270D) - 100019.b <- ffffe.b
! 	PORT_BIT ( 0x00ff, 0x0080, IPT_PADDLE ) PORT_MINMAX(0x00,0xff) PORT_SENSITIVITY(30) PORT_KEYDELTA(1)
  
  	PORT_START	// IN7 - Wheel (360) - 100019.b <- ffffe.b
! 	PORT_BIT( 0x00ff, 0x0080, IPT_DIAL ) PORT_SENSITIVITY(30) PORT_KEYDELTA(1) PORT_CODE_DEC(KEYCODE_LEFT) PORT_CODE_INC(KEYCODE_RIGHT)
  
  	PORT_START	// Fake IN1 - To be pressed during boot sequence - Code at 0x000c9e
! 	PORT_BIT( 0x0100, IP_ACTIVE_LOW, IPT_BUTTON5 ) PORT_NAME("IN 1-0") PORT_CODE(KEYCODE_H)	// "sound test"
  	PORT_BIT(  0x2000, IP_ACTIVE_LOW, IPT_UNKNOWN )
  	PORT_BIT(  0x4000, IP_ACTIVE_LOW, IPT_UNKNOWN )
  	PORT_BIT(  0x8000, IP_ACTIVE_LOW, IPT_UNKNOWN )
! 	PORT_BIT( 0x1000, IP_ACTIVE_LOW, IPT_BUTTON6 ) PORT_NAME("IN 1-4") PORT_CODE(KEYCODE_J)	// "view tiles"
! 	PORT_BIT( 0x2000, IP_ACTIVE_LOW, IPT_BUTTON7 ) PORT_NAME("IN 1-5") PORT_CODE(KEYCODE_K)	// "view memory"
! 	PORT_BIT( 0x4000, IP_ACTIVE_LOW, IPT_BUTTON8 ) PORT_NAME("IN 1-6") PORT_CODE(KEYCODE_L)	// "view sprites ?"
  	PORT_BIT(  0x8000, IP_ACTIVE_LOW, IPT_UNKNOWN )
  INPUT_PORTS_END
  
--- 1698,1728 ----
  	PORT_DIPSETTING(      0x0000, DEF_STR( On )  )
  	PORT_SERVICE( 0x8000, IP_ACTIVE_LOW )
  
! if(options.steertype!=1)
! 	{PORT_START	// IN5 - Wheel (270A) - 100019.b <- fffff.b
! 	PORT_BIT ( 0x00ff, 0x0080, IPT_PADDLE ) PORT_MINMAX(0x00,0xff) PORT_SENSITIVITY(30) PORT_KEYDELTA(1) PORT_NAME("270A Steering")
! 	
! 	PORT_START	// IN6 - FAKE
! 	PORT_BIT ( 0x00ff, 0x0080, IPT_UNUSED )
! 
! 	PORT_START	// IN7 - FAKE
! 	PORT_BIT( 0x00ff, 0x0080, IPT_UNUSED ) }
! else
! 	{PORT_START	// IN5 - FAKE
! 	PORT_BIT ( 0x00ff, 0x0080, IPT_UNUSED )PORT_START	// IN6 - Wheel (270D) - 100019.b <- ffffe.b
! 	PORT_BIT ( 0x00ff, 0x0080, IPT_PADDLE ) PORT_MINMAX(0x00,0xff) PORT_SENSITIVITY(30) PORT_KEYDELTA(1) PORT_NAME("270D Steering")
  
  	PORT_START	// IN7 - Wheel (360) - 100019.b <- ffffe.b
! 	PORT_BIT( 0x00ff, 0x0080, IPT_DIAL ) PORT_SENSITIVITY(30) PORT_KEYDELTA(1) PORT_CODE_DEC(KEYCODE_LEFT) PORT_CODE_INC(KEYCODE_RIGHT) PORT_NAME("360 Steering")}
  
  	PORT_START	// Fake IN1 - To be pressed during boot sequence - Code at 0x000c9e
! 	PORT_BIT( 0x0100, IP_ACTIVE_LOW, IPT_UNUSED ) PORT_NAME("IN 1-0") PORT_CODE(KEYCODE_H)	// "sound test"
  	PORT_BIT(  0x2000, IP_ACTIVE_LOW, IPT_UNKNOWN )
  	PORT_BIT(  0x4000, IP_ACTIVE_LOW, IPT_UNKNOWN )
  	PORT_BIT(  0x8000, IP_ACTIVE_LOW, IPT_UNKNOWN )
! 	PORT_BIT( 0x1000, IP_ACTIVE_LOW, IPT_UNUSED ) PORT_NAME("IN 1-4") PORT_CODE(KEYCODE_J)	// "view tiles"
! 	PORT_BIT( 0x2000, IP_ACTIVE_LOW, IPT_UNUSED ) PORT_NAME("IN 1-5") PORT_CODE(KEYCODE_K)	// "view memory"
! 	PORT_BIT( 0x4000, IP_ACTIVE_LOW, IPT_UNUSED ) PORT_NAME("IN 1-6") PORT_CODE(KEYCODE_L)	// "view sprites ?"
  	PORT_BIT(  0x8000, IP_ACTIVE_LOW, IPT_UNKNOWN )
  INPUT_PORTS_END
  
diff -crB c:\mame0106s\mame0106s\src/drivers/mcr3.c c:\mingw9\mame\src/drivers/mcr3.c
*** c:\mame0106s\mame0106s\src/drivers/mcr3.c	Wed May 10 21:43:14 2006
--- c:\mingw9\mame\src/drivers/mcr3.c	Fri May 18 19:59:47 2012
***************
*** 861,867 ****
  	PORT_BIT( 0x01, IP_ACTIVE_LOW, IPT_COIN1 )
  	PORT_BIT( 0x02, IP_ACTIVE_LOW, IPT_COIN2 )
  	PORT_BIT( 0x0c, IP_ACTIVE_LOW, IPT_UNUSED )
! 	PORT_BIT( 0x10, IP_ACTIVE_LOW, IPT_BUTTON6 ) PORT_NAME("Gear Shift") PORT_CODE(KEYCODE_ENTER) PORT_TOGGLE
  	PORT_BIT( 0x20, IP_ACTIVE_LOW, IPT_TILT )
  	PORT_BIT( 0x40, IP_ACTIVE_LOW, IPT_SERVICE1 )
  	PORT_SERVICE( 0x80, IP_ACTIVE_LOW )
--- 861,873 ----
  	PORT_BIT( 0x01, IP_ACTIVE_LOW, IPT_COIN1 )
  	PORT_BIT( 0x02, IP_ACTIVE_LOW, IPT_COIN2 )
  	PORT_BIT( 0x0c, IP_ACTIVE_LOW, IPT_UNUSED )
! 	if(options.geartype==0)
! {PORT_BIT( 0x10, IP_ACTIVE_HIGH, IPT_BUTTON6 ) PORT_CODE(KEYCODE_SPACE) PORT_NAME("Gear Shift");}
! else if(options.geartype==1)
! {PORT_BIT( 0x10, IP_ACTIVE_LOW, IPT_BUTTON6 ) PORT_CODE(KEYCODE_SPACE) PORT_NAME("Gear Shift");}
! else if(options.geartype==2)
! {PORT_BIT( 0x10, IP_ACTIVE_LOW, IPT_BUTTON6 ) PORT_TOGGLE PORT_CODE(KEYCODE_SPACE) PORT_NAME("Gear Shift");}
! 	
  	PORT_BIT( 0x20, IP_ACTIVE_LOW, IPT_TILT )
  	PORT_BIT( 0x40, IP_ACTIVE_LOW, IPT_SERVICE1 )
  	PORT_SERVICE( 0x80, IP_ACTIVE_LOW )
***************
*** 877,883 ****
  	PORT_BIT( 0x80, IP_ACTIVE_LOW, IPT_UNUSED )
  
  	PORT_START_TAG("SSIO.IP2")	/* J5 1-8 */
! 	PORT_BIT( 0xff, 0x30, IPT_PEDAL ) PORT_MINMAX(0x30,0xff) PORT_SENSITIVITY(100) PORT_KEYDELTA(10)
  
  	PORT_START_TAG("SSIO.IP3")	/* DIPSW @ B3 */
  	PORT_DIPNAME( 0x01, 0x01, "Game Timer" )
--- 883,889 ----
  	PORT_BIT( 0x80, IP_ACTIVE_LOW, IPT_UNUSED )
  
  	PORT_START_TAG("SSIO.IP2")	/* J5 1-8 */
! 	PORT_BIT( 0xff, 0x30, IPT_PEDAL ) PORT_MINMAX(0x30,0xff) PORT_SENSITIVITY(100) PORT_KEYDELTA(10) PORT_NAME("Gas Pedal")
  
  	PORT_START_TAG("SSIO.IP3")	/* DIPSW @ B3 */
  	PORT_DIPNAME( 0x01, 0x01, "Game Timer" )
***************
*** 897,903 ****
  	PORT_BIT( 0xff, IP_ACTIVE_LOW, IPT_UNKNOWN )
  
  	PORT_START_TAG("SSIO.IP2.ALT")
! 	PORT_BIT( 0xff, 0x74, IPT_PADDLE ) PORT_MINMAX(0x34,0xb4) PORT_SENSITIVITY(40) PORT_KEYDELTA(10)
  INPUT_PORTS_END
  
  
--- 903,909 ----
  	PORT_BIT( 0xff, IP_ACTIVE_LOW, IPT_UNKNOWN )
  
  	PORT_START_TAG("SSIO.IP2.ALT")
! 	PORT_BIT( 0xff, 0x74, IPT_PADDLE ) PORT_MINMAX(0x34,0xb4) PORT_SENSITIVITY(40) PORT_KEYDELTA(10) PORT_NAME("Steering")
  INPUT_PORTS_END
  
  
diff -crB c:\mame0106s\mame0106s\src/drivers/midvunit.c c:\mingw9\mame\src/drivers/midvunit.c
*** c:\mame0106s\mame0106s\src/drivers/midvunit.c	Mon Feb 20 10:32:40 2006
--- c:\mingw9\mame\src/drivers/midvunit.c	Sat Sep  8 12:12:43 2012
***************
*** 39,44 ****
--- 39,47 ----
  static UINT16 last_port0;
  static UINT8 shifter_state;
  
+ //static UINT16 last_port1;
+ //static UINT8 view_state;
+ 
  static void *timer[2];
  static double timer_rate;
  
***************
*** 92,97 ****
--- 95,122 ----
  	UINT16 val = readinputport(0);
  	UINT16 diff = val ^ last_port0;
  
+ if(options.geartype==2) //Sequential Shifter
+ {
+      if ((diff & 0x2000) && !(val & 0x2000)) //Gear UP handling
+      {
+            if (shifter_state==0) {shifter_state = 8;} //1st
+            else if (shifter_state==8) {shifter_state = 4;} //2nd
+            else if (shifter_state==4) {shifter_state = 2;} //3rd
+            else if (shifter_state==2) {shifter_state = 1;} //4th
+      }
+ 
+      if ((diff & 0x1000) && !(val & 0x1000)) ////Gear DOWN handling
+      {       
+            if (shifter_state==1) {shifter_state = 2;} //3rd
+            else if (shifter_state==2) {shifter_state = 4;} //2nd
+            else if (shifter_state==4) {shifter_state = 8;} //1st
+            //else if (shifter_state==8) {shifter_state = 0;} //neutral
+      }
+ 
+ }
+ 
+ else //geartype 0 or 1, original behaviour
+ {
  	/* make sure the shift controls are mutually exclusive */
  	if ((diff & 0x0400) && !(val & 0x0400))
  		shifter_state = (shifter_state == 1) ? 0 : 1;
***************
*** 101,108 ****
  		shifter_state = (shifter_state == 4) ? 0 : 4;
  	if ((diff & 0x2000) && !(val & 0x2000))
  		shifter_state = (shifter_state == 8) ? 0 : 8;
! 	last_port0 = val;
  
  	val = (val | 0x3c00) ^ (shifter_state << 10);
  
  	return (val << 16) | val;
--- 126,135 ----
  		shifter_state = (shifter_state == 4) ? 0 : 4;
  	if ((diff & 0x2000) && !(val & 0x2000))
  		shifter_state = (shifter_state == 8) ? 0 : 8;
! }
  
+ 	last_port0 = val;
+ 	
  	val = (val | 0x3c00) ^ (shifter_state << 10);
  
  	return (val << 16) | val;
***************
*** 108,117 ****
  	return (val << 16) | val;
  }
  
- 
  static READ32_HANDLER( port1_r )
  {
! 	return (readinputport(1) << 16) | readinputport(1);
  }
  
  
--- 135,176 ----
  	return (val << 16) | val;
  }
  
  static READ32_HANDLER( port1_r )
  {
!       static UINT8 cur_view = 0;
!       static UINT8 last_val = 0;
!       static UINT16 last_data = 0;
!       UINT16 viewval = readinputport(1); //actual values stored in memory
!       UINT8 button_pressed = viewval & 0x0010; 
! 
! if (last_val==button_pressed)
! return ((last_data << 16) | last_data);
! 
! if (!button_pressed) // button is pressed
! {
!  cur_view++;
!  
!          if (cur_view == 3){cur_view = 0;}
! 
!          switch (cur_view)
!          {
!          case 0:
!          viewval = (viewval | 0xf0) & 0xef;
!          break;
!          case 1:
!          viewval = (viewval | 0xf0) & 0xdf;
!          break;
!          case 2:
!          viewval = (viewval | 0xf0) & 0xbf;
!          break;
! //         case 3:
! //         viewval = (viewval | 0xf0) & 0x7f;
! //         break;
!          }
! }
! last_val=button_pressed;
! last_data = viewval;
! return (viewval << 16) | viewval;
  }
  
  
***************
*** 544,567 ****
  	PORT_BIT( 0x0020, IP_ACTIVE_LOW, IPT_UNUSED )
  	PORT_BIT( 0x0040, IP_ACTIVE_LOW, IPT_SERVICE1 )
  	PORT_BIT( 0x0080, IP_ACTIVE_LOW, IPT_COIN3 )
! 	PORT_BIT( 0x0100, IP_ACTIVE_LOW, IPT_VOLUME_DOWN )
! 	PORT_BIT( 0x0200, IP_ACTIVE_LOW, IPT_VOLUME_UP )
! 	PORT_BIT( 0x0400, IP_ACTIVE_LOW, IPT_BUTTON5 )	/* 4th */
! 	PORT_BIT( 0x0800, IP_ACTIVE_LOW, IPT_BUTTON4 )	/* 3rd */
! 	PORT_BIT( 0x1000, IP_ACTIVE_LOW, IPT_BUTTON3 )	/* 2nd */
! 	PORT_BIT( 0x2000, IP_ACTIVE_LOW, IPT_BUTTON2 )	/* 1st */
  	PORT_BIT( 0x4000, IP_ACTIVE_LOW, IPT_COIN4 )
  	PORT_BIT( 0x8000, IP_ACTIVE_LOW, IPT_UNUSED )
  
  	PORT_START
  	PORT_BIT( 0x0001, IP_ACTIVE_LOW, IPT_UNKNOWN )
! 	PORT_BIT( 0x0002, IP_ACTIVE_LOW, IPT_BUTTON6 )	/* radio */
  	PORT_BIT( 0x0004, IP_ACTIVE_LOW, IPT_UNKNOWN )
  	PORT_BIT( 0x0008, IP_ACTIVE_LOW, IPT_UNKNOWN )
! 	PORT_BIT( 0x0010, IP_ACTIVE_LOW, IPT_BUTTON2 ) PORT_PLAYER(2)	/* view 1 */
! 	PORT_BIT( 0x0020, IP_ACTIVE_LOW, IPT_BUTTON3 ) PORT_PLAYER(2)	/* view 2 */
! 	PORT_BIT( 0x0040, IP_ACTIVE_LOW, IPT_BUTTON4 ) PORT_PLAYER(2)	/* view 3 */
! 	PORT_BIT( 0x0080, IP_ACTIVE_LOW, IPT_BUTTON5 ) PORT_PLAYER(2)	/* view 4 */
  	PORT_BIT( 0xff00, IP_ACTIVE_LOW, IPT_UNUSED )
  
  	PORT_START
--- 603,636 ----
  	PORT_BIT( 0x0020, IP_ACTIVE_LOW, IPT_UNUSED )
  	PORT_BIT( 0x0040, IP_ACTIVE_LOW, IPT_SERVICE1 )
  	PORT_BIT( 0x0080, IP_ACTIVE_LOW, IPT_COIN3 )
! 	PORT_BIT( 0x0100, IP_ACTIVE_LOW, IPT_VOLUME_DOWN ) PORT_NAME("Volume Down")
! 	PORT_BIT( 0x0200, IP_ACTIVE_LOW, IPT_VOLUME_UP ) PORT_NAME("Volume Up")
! 	
! if(options.geartype==2)
! 	{PORT_BIT( 0x0400, IP_ACTIVE_LOW, IPT_UNUSED) /* 4th */
! 	PORT_BIT( 0x0800, IP_ACTIVE_LOW, IPT_UNUSED ) /* 3rd */
! 	PORT_BIT( 0x1000, IP_ACTIVE_LOW, IPT_BUTTON3 ) PORT_NAME("Gear Down")	/* Down*/
! 	PORT_BIT( 0x2000, IP_ACTIVE_LOW, IPT_BUTTON2 ) PORT_NAME("Gear Up");}	/* Up*/
! 
! else
! 	{PORT_BIT( 0x0400, IP_ACTIVE_LOW, IPT_BUTTON5 ) PORT_NAME("4th Gear")	/* 4th */
! 	PORT_BIT( 0x0800, IP_ACTIVE_LOW, IPT_BUTTON4 ) PORT_NAME("3rd Gear")	/* 3rd */
! 	PORT_BIT( 0x1000, IP_ACTIVE_LOW, IPT_BUTTON3 ) PORT_NAME("2nd Gear")	/* 2nd */
! 	PORT_BIT( 0x2000, IP_ACTIVE_LOW, IPT_BUTTON2 ) PORT_NAME("1st Gear");}	/* 1st */
! 	
  	PORT_BIT( 0x4000, IP_ACTIVE_LOW, IPT_COIN4 )
  	PORT_BIT( 0x8000, IP_ACTIVE_LOW, IPT_UNUSED )
  
  	PORT_START
  	PORT_BIT( 0x0001, IP_ACTIVE_LOW, IPT_UNKNOWN )
! 	PORT_BIT( 0x0002, IP_ACTIVE_LOW, IPT_BUTTON6 ) PORT_NAME("Radio")	/* radio */
  	PORT_BIT( 0x0004, IP_ACTIVE_LOW, IPT_UNKNOWN )
  	PORT_BIT( 0x0008, IP_ACTIVE_LOW, IPT_UNKNOWN )
! 	PORT_BIT( 0x0010, IP_ACTIVE_LOW, IPT_BUTTON7 ) PORT_NAME("View Change")	/* view change */
! 	PORT_BIT( 0x0020, IP_ACTIVE_LOW, IPT_UNUSED ) //PORT_NAME("View 2")	/* view 2 */
! 	PORT_BIT( 0x0040, IP_ACTIVE_LOW, IPT_UNUSED ) //PORT_NAME("View 3")	/* view 3 */
! 	PORT_BIT( 0x0080, IP_ACTIVE_LOW, IPT_UNUSED ) //PORT_NAME("View 4")	/* view 4 NOT WORKING IN MAME 0106*/
! 
  	PORT_BIT( 0xff00, IP_ACTIVE_LOW, IPT_UNUSED )
  
  	PORT_START
***************
*** 648,660 ****
  	PORT_DIPSETTING(      0x0e00, "Netherland-1" )
  
  	PORT_START		/* wheel */
! 	PORT_BIT( 0xff, 0x80, IPT_PADDLE ) PORT_MINMAX(0x10,0xf0) PORT_SENSITIVITY(25) PORT_KEYDELTA(20)
  
  	PORT_START		/* gas pedal */
! 	PORT_BIT( 0xff, 0x00, IPT_PEDAL ) PORT_MINMAX(0x00,0xff) PORT_SENSITIVITY(25) PORT_KEYDELTA(20)
  
  	PORT_START		/* brake pedal */
! 	PORT_BIT( 0xff, 0x00, IPT_PEDAL ) PORT_MINMAX(0x00,0xff) PORT_SENSITIVITY(25) PORT_KEYDELTA(20) PORT_PLAYER(2)
  INPUT_PORTS_END
  
  
--- 717,729 ----
  	PORT_DIPSETTING(      0x0e00, "Netherland-1" )
  
  	PORT_START		/* wheel */
! 	PORT_BIT( 0xff, 0x80, IPT_PADDLE ) PORT_MINMAX(0x10,0xf0) PORT_SENSITIVITY(25) PORT_KEYDELTA(20) PORT_NAME("Steering")
  
  	PORT_START		/* gas pedal */
! 	PORT_BIT( 0xff, 0x00, IPT_PEDAL ) PORT_MINMAX(0x00,0xff) PORT_SENSITIVITY(25) PORT_KEYDELTA(20) PORT_NAME("Gas Pedal")
  
  	PORT_START		/* brake pedal */
! 	PORT_BIT( 0xff, 0x00, IPT_PEDAL2 ) PORT_MINMAX(0x00,0xff) PORT_SENSITIVITY(25) PORT_KEYDELTA(20) PORT_NAME("Brake")
  INPUT_PORTS_END
  
  
***************
*** 668,691 ****
  	PORT_BIT( 0x0020, IP_ACTIVE_LOW, IPT_UNUSED )
  	PORT_BIT( 0x0040, IP_ACTIVE_LOW, IPT_SERVICE1 )
  	PORT_BIT( 0x0080, IP_ACTIVE_LOW, IPT_COIN3 )
! 	PORT_BIT( 0x0100, IP_ACTIVE_LOW, IPT_VOLUME_DOWN )
! 	PORT_BIT( 0x0200, IP_ACTIVE_LOW, IPT_VOLUME_UP )
! 	PORT_BIT( 0x0400, IP_ACTIVE_LOW, IPT_BUTTON5 )	/* 4th */
! 	PORT_BIT( 0x0800, IP_ACTIVE_LOW, IPT_BUTTON4 )	/* 3rd */
! 	PORT_BIT( 0x1000, IP_ACTIVE_LOW, IPT_BUTTON3 )	/* 2nd */
! 	PORT_BIT( 0x2000, IP_ACTIVE_LOW, IPT_BUTTON2 )	/* 1st */
  	PORT_BIT( 0x4000, IP_ACTIVE_LOW, IPT_COIN4 )
  	PORT_BIT( 0x8000, IP_ACTIVE_LOW, IPT_UNUSED )
  
  	PORT_START
  	PORT_BIT( 0x0001, IP_ACTIVE_LOW, IPT_UNKNOWN )
! 	PORT_BIT( 0x0002, IP_ACTIVE_LOW, IPT_BUTTON6 )	/* radio */
  	PORT_BIT( 0x0004, IP_ACTIVE_LOW, IPT_UNKNOWN )
  	PORT_BIT( 0x0008, IP_ACTIVE_LOW, IPT_UNKNOWN )
! 	PORT_BIT( 0x0010, IP_ACTIVE_LOW, IPT_BUTTON2 ) PORT_PLAYER(2)	/* view 1 */
! 	PORT_BIT( 0x0020, IP_ACTIVE_LOW, IPT_BUTTON3 ) PORT_PLAYER(2)	/* view 2 */
! 	PORT_BIT( 0x0040, IP_ACTIVE_LOW, IPT_BUTTON4 ) PORT_PLAYER(2)	/* view 3 */
! 	PORT_BIT( 0x0080, IP_ACTIVE_LOW, IPT_BUTTON5 ) PORT_PLAYER(2)	/* view 4 */
  	PORT_BIT( 0xff00, IP_ACTIVE_LOW, IPT_UNUSED )
  
  	PORT_START
--- 737,769 ----
  	PORT_BIT( 0x0020, IP_ACTIVE_LOW, IPT_UNUSED )
  	PORT_BIT( 0x0040, IP_ACTIVE_LOW, IPT_SERVICE1 )
  	PORT_BIT( 0x0080, IP_ACTIVE_LOW, IPT_COIN3 )
! 	PORT_BIT( 0x0100, IP_ACTIVE_LOW, IPT_VOLUME_DOWN ) PORT_NAME("Volume Down")
! 	PORT_BIT( 0x0200, IP_ACTIVE_LOW, IPT_VOLUME_UP ) PORT_NAME("Volume Up")
! 	
! if(options.geartype==2)
! 	{PORT_BIT( 0x0400, IP_ACTIVE_LOW, IPT_UNUSED) /* 4th */
! 	PORT_BIT( 0x0800, IP_ACTIVE_LOW, IPT_UNUSED ) /* 3rd */
! 	PORT_BIT( 0x1000, IP_ACTIVE_LOW, IPT_BUTTON3 ) PORT_NAME("Gear Down")	/* Down*/
! 	PORT_BIT( 0x2000, IP_ACTIVE_LOW, IPT_BUTTON2 ) PORT_NAME("Gear Up");}	/* Up*/
! 
! else
! 	{PORT_BIT( 0x0400, IP_ACTIVE_LOW, IPT_BUTTON5 ) PORT_NAME("4th Gear")	/* 4th */
! 	PORT_BIT( 0x0800, IP_ACTIVE_LOW, IPT_BUTTON4 ) PORT_NAME("3rd Gear")	/* 3rd */
! 	PORT_BIT( 0x1000, IP_ACTIVE_LOW, IPT_BUTTON3 ) PORT_NAME("2nd Gear")	/* 2nd */
! 	PORT_BIT( 0x2000, IP_ACTIVE_LOW, IPT_BUTTON2 ) PORT_NAME("1st Gear");}	/* 1st */
  	PORT_BIT( 0x4000, IP_ACTIVE_LOW, IPT_COIN4 )
  	PORT_BIT( 0x8000, IP_ACTIVE_LOW, IPT_UNUSED )
  
  	PORT_START
  	PORT_BIT( 0x0001, IP_ACTIVE_LOW, IPT_UNKNOWN )
! 	PORT_BIT( 0x0002, IP_ACTIVE_LOW, IPT_BUTTON6 ) PORT_NAME("Radio") /* radio */
  	PORT_BIT( 0x0004, IP_ACTIVE_LOW, IPT_UNKNOWN )
  	PORT_BIT( 0x0008, IP_ACTIVE_LOW, IPT_UNKNOWN )
! 	PORT_BIT( 0x0010, IP_ACTIVE_LOW, IPT_BUTTON7 ) PORT_NAME("View Change")	/* view change */
! 	PORT_BIT( 0x0020, IP_ACTIVE_LOW, IPT_UNUSED ) //PORT_NAME("View 2")	/* view 2 */
! 	PORT_BIT( 0x0040, IP_ACTIVE_LOW, IPT_UNUSED ) //PORT_NAME("View 3")	/* view 3 */
! 	PORT_BIT( 0x0080, IP_ACTIVE_LOW, IPT_UNUSED ) //PORT_NAME("View 4")	/* view 4 NOT EFFECTIVE IN MAME 0.106 */
! 
  	PORT_BIT( 0xff00, IP_ACTIVE_LOW, IPT_UNUSED )
  
  	PORT_START
***************
*** 769,781 ****
  	PORT_DIPSETTING(      0x0e00, "Netherland-1" )
  
  	PORT_START		/* wheel */
! 	PORT_BIT( 0xff, 0x80, IPT_PADDLE ) PORT_MINMAX(0x10,0xf0) PORT_SENSITIVITY(25) PORT_KEYDELTA(20)
  
  	PORT_START		/* gas pedal */
! 	PORT_BIT( 0xff, 0x00, IPT_PEDAL ) PORT_MINMAX(0x00,0xff) PORT_SENSITIVITY(25) PORT_KEYDELTA(20)
  
  	PORT_START		/* brake pedal */
! 	PORT_BIT( 0xff, 0x00, IPT_PEDAL ) PORT_MINMAX(0x00,0xff) PORT_SENSITIVITY(25) PORT_KEYDELTA(20) PORT_PLAYER(2)
  INPUT_PORTS_END
  
  
--- 847,859 ----
  	PORT_DIPSETTING(      0x0e00, "Netherland-1" )
  
  	PORT_START		/* wheel */
! 	PORT_BIT( 0xff, 0x80, IPT_PADDLE ) PORT_MINMAX(0x10,0xf0) PORT_SENSITIVITY(25) PORT_KEYDELTA(20) PORT_NAME("Steering")
  
  	PORT_START		/* gas pedal */
! 	PORT_BIT( 0xff, 0x00, IPT_PEDAL ) PORT_MINMAX(0x00,0xff) PORT_SENSITIVITY(25) PORT_KEYDELTA(20) PORT_NAME("Gas Pedal")
  
  	PORT_START		/* brake pedal */
! 	PORT_BIT( 0xff, 0x00, IPT_PEDAL2 ) PORT_MINMAX(0x00,0xff) PORT_SENSITIVITY(25) PORT_KEYDELTA(20) PORT_NAME("Brake")
  INPUT_PORTS_END
  
  
***************
*** 789,812 ****
  	PORT_BIT( 0x0020, IP_ACTIVE_LOW, IPT_UNUSED )
  	PORT_BIT( 0x0040, IP_ACTIVE_LOW, IPT_SERVICE1 )
  	PORT_BIT( 0x0080, IP_ACTIVE_LOW, IPT_COIN3 )
! 	PORT_BIT( 0x0100, IP_ACTIVE_LOW, IPT_VOLUME_DOWN )
! 	PORT_BIT( 0x0200, IP_ACTIVE_LOW, IPT_VOLUME_UP )
! 	PORT_BIT( 0x0400, IP_ACTIVE_LOW, IPT_BUTTON5 )	/* 4th */
! 	PORT_BIT( 0x0800, IP_ACTIVE_LOW, IPT_BUTTON4 )	/* 3rd */
! 	PORT_BIT( 0x1000, IP_ACTIVE_LOW, IPT_BUTTON3 )	/* 2nd */
! 	PORT_BIT( 0x2000, IP_ACTIVE_LOW, IPT_BUTTON2 )	/* 1st */
  	PORT_BIT( 0x4000, IP_ACTIVE_LOW, IPT_COIN4 )
  	PORT_BIT( 0x8000, IP_ACTIVE_LOW, IPT_UNUSED )
  
  	PORT_START
  	PORT_BIT( 0x0001, IP_ACTIVE_LOW, IPT_UNKNOWN )
! 	PORT_BIT( 0x0002, IP_ACTIVE_LOW, IPT_BUTTON6 )	/* radio */
  	PORT_BIT( 0x0004, IP_ACTIVE_LOW, IPT_UNKNOWN )
  	PORT_BIT( 0x0008, IP_ACTIVE_LOW, IPT_UNKNOWN )
! 	PORT_BIT( 0x0010, IP_ACTIVE_LOW, IPT_BUTTON2 ) PORT_PLAYER(2)	/* view 1 */
! 	PORT_BIT( 0x0020, IP_ACTIVE_LOW, IPT_BUTTON3 ) PORT_PLAYER(2)	/* view 2 */
! 	PORT_BIT( 0x0040, IP_ACTIVE_LOW, IPT_BUTTON4 ) PORT_PLAYER(2)	/* view 3 */
! 	PORT_BIT( 0x0080, IP_ACTIVE_LOW, IPT_BUTTON5 ) PORT_PLAYER(2)	/* view 4 */
  	PORT_BIT( 0xff00, IP_ACTIVE_LOW, IPT_UNUSED )
  
  	PORT_START
--- 867,898 ----
  	PORT_BIT( 0x0020, IP_ACTIVE_LOW, IPT_UNUSED )
  	PORT_BIT( 0x0040, IP_ACTIVE_LOW, IPT_SERVICE1 )
  	PORT_BIT( 0x0080, IP_ACTIVE_LOW, IPT_COIN3 )
! 	PORT_BIT( 0x0100, IP_ACTIVE_LOW, IPT_VOLUME_DOWN ) PORT_NAME("Volume Down")
! 	PORT_BIT( 0x0200, IP_ACTIVE_LOW, IPT_VOLUME_UP ) PORT_NAME("Volume Up")
! 	
! if(options.geartype==2)
! 	{PORT_BIT( 0x0400, IP_ACTIVE_LOW, IPT_UNUSED) /* 4th */
! 	PORT_BIT( 0x0800, IP_ACTIVE_LOW, IPT_UNUSED ) /* 3rd */
! 	PORT_BIT( 0x1000, IP_ACTIVE_LOW, IPT_BUTTON3 ) PORT_NAME("Gear Down")	/* Down*/
! 	PORT_BIT( 0x2000, IP_ACTIVE_LOW, IPT_BUTTON2 ) PORT_NAME("Gear Up");}	/* Up*/
! 
! else
! 	{PORT_BIT( 0x0400, IP_ACTIVE_LOW, IPT_BUTTON5 ) PORT_NAME("4th Gear")	/* 4th */
! 	PORT_BIT( 0x0800, IP_ACTIVE_LOW, IPT_BUTTON4 ) PORT_NAME("3rd Gear")	/* 3rd */
! 	PORT_BIT( 0x1000, IP_ACTIVE_LOW, IPT_BUTTON3 ) PORT_NAME("2nd Gear")	/* 2nd */
! 	PORT_BIT( 0x2000, IP_ACTIVE_LOW, IPT_BUTTON2 ) PORT_NAME("1st Gear");}	/* 1st */
  	PORT_BIT( 0x4000, IP_ACTIVE_LOW, IPT_COIN4 )
  	PORT_BIT( 0x8000, IP_ACTIVE_LOW, IPT_UNUSED )
  
  	PORT_START
  	PORT_BIT( 0x0001, IP_ACTIVE_LOW, IPT_UNKNOWN )
! 	PORT_BIT( 0x0002, IP_ACTIVE_LOW, IPT_BUTTON6 ) PORT_NAME("Radio")	/* radio */
  	PORT_BIT( 0x0004, IP_ACTIVE_LOW, IPT_UNKNOWN )
  	PORT_BIT( 0x0008, IP_ACTIVE_LOW, IPT_UNKNOWN )
! 	PORT_BIT( 0x0010, IP_ACTIVE_LOW, IPT_BUTTON7 ) PORT_NAME("View 1")	/* view 1 */
! 	PORT_BIT( 0x0020, IP_ACTIVE_LOW, IPT_BUTTON8 ) PORT_NAME("View 2")	/* view 2 */
! 	PORT_BIT( 0x0040, IP_ACTIVE_LOW, IPT_BUTTON9 ) PORT_NAME("View 3")	/* view 3 */
! 	PORT_BIT( 0x0080, IP_ACTIVE_LOW, IPT_BUTTON10 ) PORT_NAME("View 4")	/* view 4 */
  	PORT_BIT( 0xff00, IP_ACTIVE_LOW, IPT_UNUSED )
  
  	PORT_START
***************
*** 864,876 ****
  	PORT_DIPSETTING(      0x6800, "Hungary 1" )
  
  	PORT_START		/* wheel */
! 	PORT_BIT( 0xff, 0x80, IPT_PADDLE ) PORT_MINMAX(0x10,0xf0) PORT_SENSITIVITY(25) PORT_KEYDELTA(20)
  
  	PORT_START		/* gas pedal */
! 	PORT_BIT( 0xff, 0x00, IPT_PEDAL ) PORT_MINMAX(0x00,0xff) PORT_SENSITIVITY(25) PORT_KEYDELTA(20)
  
  	PORT_START		/* brake pedal */
! 	PORT_BIT( 0xff, 0x00, IPT_PEDAL ) PORT_MINMAX(0x00,0xff) PORT_SENSITIVITY(25) PORT_KEYDELTA(20) PORT_PLAYER(2)
  INPUT_PORTS_END
  
  
--- 950,962 ----
  	PORT_DIPSETTING(      0x6800, "Hungary 1" )
  
  	PORT_START		/* wheel */
! 	PORT_BIT( 0xff, 0x80, IPT_PADDLE ) PORT_MINMAX(0x10,0xf0) PORT_SENSITIVITY(25) PORT_KEYDELTA(20) PORT_NAME("Steering")
  
  	PORT_START		/* gas pedal */
! 	PORT_BIT( 0xff, 0x00, IPT_PEDAL ) PORT_MINMAX(0x00,0xff) PORT_SENSITIVITY(25) PORT_KEYDELTA(20) PORT_NAME("Gas Pedal")
  
  	PORT_START		/* brake pedal */
! 	PORT_BIT( 0xff, 0x00, IPT_PEDAL2 ) PORT_MINMAX(0x00,0xff) PORT_SENSITIVITY(25) PORT_KEYDELTA(20) PORT_NAME("Brake")
  INPUT_PORTS_END
  
  
